package org.potatohed.sectorunit;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.util.MutableValue;
import org.junit.ClassRule;
import org.junit.Test;
import org.mockito.MockingDetails;
import org.mockito.Mockito;

import static org.junit.Assert.assertTrue;
import static org.mockito.ArgumentMatchers.any;
import static org.mockito.ArgumentMatchers.anyFloat;
import static org.mockito.Mockito.*;

public class MockedGlobalTest {

    @ClassRule
    public static MockedGlobal mockedGlobal = new MockedGlobal();


    private void assertIsMock(Object obj) {
        MockingDetails details = Mockito.mockingDetails(obj);
        assertTrue("Expected Object to be Mock", details.isMock());
    }

    @Test
    public void all_returns_are_mocked() {
        assertIsMock(Global.getSector());
        assertIsMock(Global.getFactory());
        assertIsMock(Global.getCombatEngine());
        assertIsMock(Global.getSettings());
        assertIsMock(Global.getSoundPlayer());
    }

    @Test
    public void modifyPlayerCredits(){
        MutableValue credits = Global.getSector().getPlayerFleet().getCargo().getCredits();
        doNothing().when(credits).add(anyFloat());

        methodThatAddsCredits();

        verify(credits, times(1)).add(anyFloat());

    }

    private void methodThatAddsCredits() {
        Global.getSector().getPlayerFleet().getCargo().getCredits().add(100);
    }

}