package com.fs.starfarer.api.loading;

import java.util.EnumSet;
import java.util.List;
import java.util.Set;

import org.lwjgl.util.vector.Vector2f;

import com.fs.starfarer.api.characters.MutableCharacterStatsAPI;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.WeaponAPI;
import com.fs.starfarer.api.combat.WeaponAPI.DerivedWeaponStatsAPI;
import com.fs.starfarer.api.combat.WeaponAPI.WeaponSize;
import com.fs.starfarer.api.combat.WeaponAPI.WeaponType;

public interface WeaponSpecAPI {
	float getOrdnancePointCost(MutableCharacterStatsAPI stats);
	EnumSet<WeaponAPI.AIHints> getAIHints();
	
	WeaponType getType();
	float getAmmoPerSecond();
	
	int getTier();
	float getBaseValue();
	boolean usesAmmo();
	int getMaxAmmo();
	String getWeaponId();
	WeaponSize getSize();
	String getWeaponName();
	
	int getBurstSize();
	Set<String> getTags();
	void addTag(String tag);
	boolean hasTag(String tag);
	float getRarity();
	void setRarity(float rarity);
	float getOrdnancePointCost(MutableCharacterStatsAPI stats, MutableShipStatsAPI shipStats);
	DerivedWeaponStatsAPI getDerivedStats();
	
	List<Vector2f> getHardpointFireOffsets();
	List<Float> getHardpointAngleOffsets();
	List<Vector2f> getTurretFireOffsets();
	List<Float> getTurretAngleOffsets();
	List<Vector2f> getHiddenFireOffsets();
	List<Float> getHiddenAngleOffsets();
}
